//<#!@READ-ONLY-SECTION-START@!#>
/*
 * \class cfm_betterfunction
 * \brief Intel(R) CoFluent(TM) Studio - Intel Corporation
 * \details Simulation model of AIC_MU_ProjectApp generated by C++ Generator for SystemC/TLM2
 */
#include "cfm_betterfunction.h"
using namespace std;
using namespace sc_core;
using namespace cf_dt;
using namespace cf_pk;
using namespace cf_core;

//<#!@READ-ONLY-SECTION-END@!#>
//Start of 'BetterFunction definitions' algorithm generated code

//End of 'BetterFunction definitions' algorithm generated code
//<#!@READ-ONLY-SECTION-START@!#>

/// \name constructor
//@{
cfm_betterfunction::cfm_betterfunction(sc_core::sc_module_name name) :
		cf_function(name), cfm_betterfunction_dp_if(), bestOperation(
				"bestOperation"), init("init") {
	cf_function::init();

	// operations initialization
	CF_OPERATION(bestOperation, cfm_op_bestOperation);
	bestOperation.init();
	CF_OPERATION(init, cfm_op_init);
	init.init();

	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'BetterFunction constructor' algorithm generated code

	//End of 'BetterFunction constructor' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>

	SC_THREAD (cfm_behavior);

	cf_function::elab_end();
}
//@}

/// \name destructor
//@{
cfm_betterfunction::~cfm_betterfunction(void) {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'BetterFunction destructor' algorithm generated code

	//End of 'BetterFunction destructor' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
}
//@}

/// \name pre-elaboration section
//@{
void cfm_betterfunction::cb_before_elaboration(void) {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'BetterFunction pre elaboration' algorithm generated code

	//End of 'BetterFunction pre elaboration' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
}
//@}

/// \name initialize attributes
//@{
void cfm_betterfunction::cb_init_attributes() {

// initialize function attributes
	cfa_do_not_start.init(false);
// cfa_affinity.init();
	cfa_priority.init((cf_count) 0);

	cfa_policy.init(CF_SCHEDULER_POLICY_FF);
	cfa_time_slice.init(cf_expr_duration(10, CF_MS));
	cfa_static_code_size.init(cf_data_size(0, CF_KBYTE));
	cfa_static_data_size.init(cf_data_size(0, CF_KBYTE));
	cfa_static_power.init(cf_power(0, CF_UW));
	cfa_dynamic_power.init(cf_power(0, CF_UW));
	cfa_cost.init(cf_cost(0, CF_USD));
	cfa_dynamic_load.init(cf_resource_load(100, CF_PERCENT));

// initialize operation attributes
	bestOperation.cfa_type.init(CF_OP_TYPE_ACTIVE);
	bestOperation.cfa_execution_time.init(cf_expr_duration(10, CF_NS));
	bestOperation.cfa_dynamic_data_size.init(cf_data_size(0, CF_KBYTE));
	init.cfa_type.init(CF_OP_TYPE_ACTIVE);
	init.cfa_execution_time.init(cf_expr_duration(10, CF_NS));
	init.cfa_dynamic_data_size.init(cf_data_size(0, CF_KBYTE));
	return;
}
//@}

/// \name initialize definitions
//@{
void cfm_betterfunction::cb_init_local_vars(void) {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'BetterFunction initializations' algorithm generated code

	//End of 'BetterFunction initializations' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
}
//@}

/// \name behavioral model of the BetterFunction function
//@{
void cfm_betterfunction::cfm_behavior() {

	behavior_initialize();

	// run init
	run_operation (init);

	while (1) {

		// run bestOperation
		run_operation (bestOperation);
	}

	behavior_finalize();
}
//@}
/// \name operation algorithm for bestOperation
//@{
void cfm_betterfunction::cfm_op_bestOperation() {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'bestOperation operation' algorithm generated code
	cf_trace_report("loopDP is %d", loopDP.get_value());
	loopDP = loopDP++;
	//End of 'bestOperation operation' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
	return;
}
//@}
/// \name operation algorithm for init
//@{
void cfm_betterfunction::cfm_op_init() {
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'init operation' algorithm generated code

	//End of 'init operation' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>
	return;
}
//@}


//<#!@READ-ONLY-SECTION-END@!#>